%% ------------------------------------------------------------------------- %%
\chapter{MsFLOSS Requirements and Architecture}
\label{ap:msflossreq}

\section{First Version Requirements}

We are interested in the following information:

\section{Mailing List}
\textit{\textbf{Prerequisite}}
Choose a mainstream list of related project

\textbf{To} 
\begin{itemize}
\item Are the receivers all project maintainers? 
\item How many people answer (review) the patch?
\end{itemize}

\textbf{From}
\begin{itemize}
\item Does the sender represent an institution?
\end{itemize}

\textbf{Subject}
\begin{itemize}
\item Match thread to commit
\item Identify the subsystem
\item Filter prefix:
\begin{itemize}
  \item PATCH: Define the number of iterations (V2, V3, v4...)
  \item RFC
\begin{itemize}
    \item How many replies (comments) did this e-mail receive?
    \item Did this e-mail create a patch? How many lines would be modified if the changes were applied?
\end{itemize}
  \item Cover-letter (PATCH v0)
  \item For-CI
\end{itemize}
\end{itemize}

\textbf{Body}
\begin{itemize}
\item Number of comments in a reply: which refers to the commit message and which refers to the code
\item Comments focus on the same problem (i.e. is there a discussion)?
\item What are the feelings in the discussion?
\end{itemize}

\section{Git repository}

\textbf{Author}
\begin{itemize}
\item What kind of contributor:
\begin{itemize}
  \item Representing an institution or using personal profile? (From e-mail)
  \item How long has he/she been a contributor of the project?
  \item Has he/she a role (e.g. maintainer) inside the project repository?
\end{itemize}
\item How many contributions/commits he/she made on the last week, on the last month, on the last year and on the history of the project?
\end{itemize}

\textbf{Commit}
\begin{itemize}
\item Title - commit message:
\begin{itemize}
  \item Identify the subsystem
\end{itemize}
\item Description:
\begin{itemize}
  \item Tags (quantity and value):
\begin{itemize}
    \item "R-b: <name>", "S-o-b: <name>", "T-b: <name>"
    \item Fixes
    \item Patchwork
    \item Others
\end{itemize}
  \item Diff:
\begin{itemize}
    \item Qty of lines changed, added, removed... (+,-)
    \item Qty of files modified
\end{itemize}
\end{itemize}
\end{itemize}

\section{IRC}

\textbf{Message}
\begin{itemize}
\item Date-time: what are the periods of intense interaction in the channel?
\item Author: name, e-mail, any other profile information.
\item Message: what subjects are often discussed in the channel?
\end{itemize}

\section{Architecture Design}

\begin{figure}[ht]
	\centering
	\includegraphics[width=0.7\textwidth]{figure/msfloss.png}
	\caption{FLOSS Projects Data Collection Platform} \label{fig:msfloss}
\end{figure}

Figure \ref{fig:msfloss} describes the top-level architecture design of the
microservice-oriented platform. The system is composed of: four robots to
gather community data (Git Commit, IRC, Issue Tracker, Mailing List), a gateway
and user interface (front-end and data visualization). The arrow indicates the
direction of the data requests. 
